<?php

namespace FiloBlu\ExtTargetRule\Block\Catalog\Product\ProductList;

use FiloBlu\ExtTargetRule\Helper\Data;

class Upsell extends \Magento\TargetRule\Block\Catalog\Product\ProductList\Upsell
{
    /**
     * @var \Magento\Catalog\Block\Product\Context
     */
    protected $context;

    public function __construct(
        \Magento\Catalog\Block\Product\Context $context ,
        \Magento\TargetRule\Model\ResourceModel\Index $index ,
        \Magento\TargetRule\Helper\Data $targetRuleData ,
        \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollectionFactory ,
        \Magento\Catalog\Model\Product\Visibility $visibility ,
        \Magento\TargetRule\Model\IndexFactory $indexFactory ,
        \Magento\Checkout\Model\Cart $cart ,
        array $data = []
    )
    {
        parent::__construct($context , $index , $targetRuleData , $productCollectionFactory , $visibility , $indexFactory , $cart , $data);
        $this->context = $context;
    }

    public function getUpsellAjaxUrl()
    {
        //get site base url
        /** @var \Magento\Store\Model\StoreManagerInterface $baseUrl */
        $baseUrl = $this->_storeManager->getStore()->getBaseUrl();

        //get current product
        /** @var \Magento\Catalog\Model\Product $product */
        $product = $this->getProduct();

        return $baseUrl . "exttargetrule/products/upsellAjax/id/" . $product->getEntityId();
    }

    protected function getCacheLifetime()
    {
        return null; // TODO: Change the autogenerated stub
    }

    public function setTemplate($template)
    {
        if ($this->context->getScopeConfig()->getValue(Data::EXT_AJAX_ENABLED)) {
            if ($template == 'Magento_Catalog::product/list/items.phtml') {
                $template = null;
            }
        } else {
            if ($template == 'FiloBlu_ExtTargetRule::upsell.phtml') {
                $template = null;
            }
        }

        return parent::setTemplate($template); // TODO: Change the autogenerated stub
    }
}